﻿using System.Globalization;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            Loaded += Window_Loaded;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 윈도우 로드시 처리하기 - Window_Loaded(sender, e)

        /// <summary>
        /// 윈도우 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            FormattedText formattedText = new FormattedText
            (
                "ABC",
                new CultureInfo("en-us"),
                FlowDirection.LeftToRight,
                new Typeface
                (
                    new FontFamily("Times New Roman"),
                    FontStyles.Normal,
                    FontWeights.Normal,
                    new FontStretch()
                ),
                96,
                Brushes.White
            );

            DrawingVisual drawingVisual = new DrawingVisual();

            DrawingContext drawingContext = drawingVisual.RenderOpen();

            drawingContext.DrawRectangle
            (
                Brushes.RoyalBlue,
                new Pen(Brushes.RoyalBlue, 0),
                new Rect
                (
                    0,
                    0,
                    formattedText.Width,
                    formattedText.Height
                )
            );

            drawingContext.DrawText(formattedText, new Point(0, 0));

            drawingContext.Close();

            RenderTargetBitmap renderTargetBitmap = new RenderTargetBitmap
            (
                (int)formattedText.Width,
                (int)formattedText.Height,
                96,
                96,
                PixelFormats.Pbgra32
            );

            renderTargetBitmap.Render(drawingVisual);

            this.image.Source = renderTargetBitmap;
        }

        #endregion
    }
}